/*
  This file is part of SLS.
  Copyright (C) 2008 Sebastien LUTTRINGER <contact@seblu.net>

  SLS is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; version 2 of the License.

  SLS is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with SLS; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "sls.hh"
#include "client.hh"

/*******************************************************************************
** Method of Classes
*******************************************************************************/
Client *Client::login(Connection &c) {
  string slogin = c.recvln();
  string spass = c.recvln();

  // FIXME: find better method than fucking magic number
  char loginbuf[512];
  char passbuf[512];


  if (sscanf(spass.c_str(), "PASS %512s\n", passbuf) != 1)
    return login_fail(c);

  if (sscanf(slogin.c_str(), "HOST %512s\n", loginbuf) == 1) {
    // check login and password

    // Register login and pass in client

    // Print succefful login
    std::cout << "Connection id " << c.getid() << ": Host " << loginbuf 
	      << " logged from " << c.getremoteip()
	      << " on port " << c.getremoteport() << ".\n";
    return new Daemon(c);
  }
  else if (sscanf(slogin.c_str(), "USER %512s\n", loginbuf) == 1) {
    return new Console(c);
  }

  return login_fail(c);
}

Client *Client::login_fail(Connection &c) {
  std::cout << "Connection id " << c.getid() << ": Bad authentification.\n";
  c.sendln("Bad authentification.");
  return 0;
}

/*******************************************************************************
** Public Classes
*******************************************************************************/

Client::Client(Connection &c) : c_ (c) {}

Client::~Client() {}



void Client::exec() {
  assert(0);
}
